<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="管理地址" prop="adminIp">
        <el-input v-model="formData.adminIp" placeholder="请输入管理地址" />
      </el-form-item>
      <el-form-item label="管理账号" prop="username">
        <el-input v-model="formData.username" placeholder="请输入管理账号" />
      </el-form-item>
      <el-form-item label="管理密码" prop="password">
        <el-input v-model="formData.password" placeholder="请输入管理密码" />
      </el-form-item>
      <el-form-item label="网关名字" prop="gatewayName">
        <el-input v-model="formData.gatewayName" placeholder="请输入网关名字" />
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注" />
      </el-form-item>
      <el-form-item label="是否启用" prop="isEnable">
        <el-radio-group v-model="formData.isEnable">
          <el-radio
            v-for="dict in getBoolDictOptions(DICT_TYPE.INFRA_BOOLEAN_STRING)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="网关编码" prop="gatewayCode">
        <el-input v-model="formData.gatewayCode" placeholder="请输入网关编码" />
      </el-form-item>
      <el-form-item label="网关状态" prop="gatewayStatus">
        <el-radio-group v-model="formData.gatewayStatus">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.IOT_GATEWAY_STATUS)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="订阅主题" prop="topic">
        <el-input v-model="formData.topic" placeholder="请输入订阅主题" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import {getStrDictOptions, DICT_TYPE, getBoolDictOptions} from '@/utils/dict'
import { GatewayApi, GatewayVO } from '@/api/iot/gateway'

/** 网关 表单 */
defineOptions({ name: 'GatewayForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  adminIp: undefined,
  username: undefined,
  password: undefined,
  gatewayName: undefined,
  remark: undefined,
  isEnable: undefined,
  gatewayCode: undefined,
  gatewayStatus: undefined,
  topic: undefined,
})
const formRules = reactive({
  isEnable: [{ required: true, message: '是否启用不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await GatewayApi.getGateway(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as GatewayVO
    if (formType.value === 'create') {
      await GatewayApi.createGateway(data)
      message.success(t('common.createSuccess'))
    } else {
      await GatewayApi.updateGateway(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    adminIp: undefined,
    username: undefined,
    password: undefined,
    gatewayName: undefined,
    remark: undefined,
    isEnable: undefined,
    gatewayCode: undefined,
    gatewayStatus: undefined,
    topic: undefined,
  }
  formRef.value?.resetFields()
}
</script>
